
char szLibNULL[] = "";
char szLibCHAR[8];
#include "proto.h"

char *fnlibCharToString( char c )
{
	if ( !isprint(c) )
		return szLibNULL;
	szLibCHAR[0] = c, szLibCHAR[1] = 0;
	return szLibCHAR;
}

extern int iMaster, iReset;

int i2c_slave_recv(i2c_dev_t *dev, char *buf, int len, int stop)
{
	int iLen = len, iCount = 0;
	int status, timeout;

//	printf( "Slave receive\n" );
//	out16(dev->regbase + AM335x_I2C_SBLOCK, AM335x_OAE0 );			// Tell it to only use OA0
	while ( iLen )
	{
//	    out16(dev->regbase + AM335x_I2C_CNT, 1);
//		printf( "Slave Read 1 Control 0x%X Status 0x%X\n", in16(dev->regbase + I2C_CTRREG_OFF), in16(dev->regbase + I2C_STSREG_OFF) );
		timeout = 3000;
		while ( --timeout && ( ( ( status = in16(dev->regbase + I2C_STSREG_OFF) ) & AM335x_I2C_SLV_RCV ) != AM335x_I2C_SLV_RCV &&
				!( status & ( AM335x_I2C_ERROR | AM335x_I2C_ARDY ) ) ) );
		if ( !timeout )
		{
//			if ( status == AM335x_I2C_AAS )
			{
				printf("Fake successful read of %d bytes\n", iCount );
				return iCount;
			}
			slogf(_SLOGC_SNELL_IQMIT_I2C_DRIVER, _SLOG_ERROR, "%s:i2c_slave_receive: timeout RCV status 0x%X, so reset", pszProgram, status );
			printf( "Slave Read 2 Timeout Control 0x%X Status 0x%X\n", in16(dev->regbase + I2C_CTRREG_OFF), in16(dev->regbase + I2C_STSREG_OFF) );
			iReset = 100;
			i2c_reset(dev);
			return -1;
		}
		if ( iMaster )
			return -1;
		// Any other errors reported???
		if (status & AM335x_I2C_ERROR)
		{
			if ( uiVerbosity >= LOGGING_DEBUG_FINE )
				slogf(_SLOGC_SNELL_IQMIT_I2C_DRIVER, _SLOG_WARNING,
						"%s:i2c_slave_recv: Error reported status 0x%X return EIO (CTRREG 0x%X STSREG 0x%X)",
						pszProgram, status, in16(dev->regbase + I2C_CTRREG_OFF), in16(dev->regbase + I2C_STSREG_OFF));
			printf( "Slave Read fail status 0x%X\n", status );
			errno =  EIO;
			i2c_reset(dev);
			return -2;
		}
		if ( ( status & ( AM335x_I2C_ARDY ) )  )	// || !(status & AM335x_I2C_BB ) )
		{
			printf( "Slave Read Stop found after reading %d bytes status 0x%X\n", iCount, status );
			if ( uiVerbosity >= LOGGING_DEBUG_FINE )
				slogf(_SLOGC_SNELL_IQMIT_I2C_DRIVER, _SLOG_DEBUG2,
						"%s:i2c_slave_recv: Stop received, return %d bytes", pszProgram, iCount);
//			out16( dev->regbase + AM335x_I2C_STAT, AM335x_I2C_ARDY | AM335x_I2C_BF );
//			if ( in16( dev->regbase + AM335x_I2C_CNT ) )
//				out16(dev->regbase + AM335x_I2C_CNT, 0);
			return iCount;
		}
		// read byte
		char cByte = buf[iCount++] = in16(dev->regbase + I2C_DATREG_OFF) & 0xFF;
		out16(dev->regbase + AM335x_I2C_STAT, status & ( AM335x_I2C_RRDY | AM335x_I2C_BF ) ); // | AM335x_I2C_ROVR );
		iLen--;
		if ( uiVerbosity >= LOGGING_PROGRESS )
			slogf(_SLOGC_SNELL_IQMIT_I2C_DRIVER, _SLOG_INFO,
					"%s:i2c_slave_recv: Byte %d is 0x%02X '%s', (CTRREG 0x%X STSREG 0x%X)", pszProgram, iCount, (unsigned char)cByte,
					fnlibCharToString( cByte ), in16(dev->regbase + I2C_CTRREG_OFF), in16(dev->regbase + I2C_STSREG_OFF));
		printf( "\In Byte %d is 0x%02X statraw 0x%X status 0x%X...\n", iCount, cByte & 0x0FF, status, in16(dev->regbase + AM335x_I2C_STAT) );
		/*wait for interrupt */
//		status = i2c_slave_wait_status(dev);
//		out16(dev->regbase + AM335x_I2C_SBLOCK, 0 );					// Tell it to only use OA0
//		delay(1);
//		out16(dev->regbase + AM335x_I2C_SBLOCK, AM335x_OAE0 );			// Tell it to only use OA0
	}
	if (uiVerbosity >=  LOGGING_ERRORS)
		slogf( _SLOGC_SNELL_IQMIT_I2C_DRIVER, _SLOG_ERROR,
				"%s:i2c_slave_recv: %d buffer overrun return -1 errno EMSGSIZE", pszProgram, len);
	i2c_reset(dev);
	errno = EMSGSIZE;
//	out16(dev->regbase + AM335x_I2C_SBLOCK, 0 );			// Tell it to only use OA0
	return -10;
}

